<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryForm" :inline="true" v-show="showSearch" label-width="100px">
      <el-form-item label="公司名" prop="companyId">
          <el-select filterable style="width: 220px" v-model="queryParams.companyId" placeholder="请选择公司名" @change="companyChange" clearable size="small">
              <el-option
                v-for="item in companys"
                :key="item.companyId"
                :label="item.companyName"
                :value="item.companyId"
              />
        </el-select>
      </el-form-item>
     <el-form-item >
          <treeselect style="width: 220px" :clearable="false"  v-model="queryParams.deptId"  :options="deptOptions" :show-count="true" placeholder="请选择归属部门" />
     </el-form-item>

       <el-form-item label="员工姓名" prop="userNickName">
        <el-input
        style="width: 220px"
          v-model="queryParams.userNickName"
          placeholder="请输入员工姓名"
          clearable
          size="small"
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item label="主叫" prop="callerPhone">
        <el-input
          style="width: 220px"
          v-model="queryParams.callerPhone"
          placeholder="请输入主叫"
          clearable
          size="small"
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item label="被叫" prop="calleePhone">
        <el-input
          style="width: 220px"
          v-model="queryParams.calleePhone"
          placeholder="请输入被叫"
          clearable
          size="small"
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item label="状态" prop="status">
        <el-select v-model="queryParams.status" placeholder="请选择" clearable size="small">
          <el-option
            v-for="dict in statusOptions"
            :key="dict.dictValue"
            :label="dict.dictLabel"
            :value="dict.dictValue"
          />
        </el-select>
      </el-form-item>
      <el-form-item label="来源渠道" prop="source">
        <el-select v-model="queryParams.source" placeholder="请选择" clearable size="small">
          <el-option
            v-for="dict in sourceOptions"
            :key="dict.dictValue"
            :label="dict.dictLabel"
            :value="dict.dictValue"
          />
        </el-select>
      </el-form-item>
      <el-form-item label="时长" prop="times">
        <el-select v-model="queryParams.times" placeholder="请选择" clearable size="small">
          <el-option
            v-for="dict in timesOptions"
            :key="dict.dictValue"
            :label="dict.dictLabel"
            :value="dict.dictValue"
          />
        </el-select>
      </el-form-item>
      <el-form-item label="开始时间" prop="startTime">
         <el-date-picker v-model="dateRange" size="small" style="width: 220px" value-format="yyyy-MM-dd" type="daterange" range-separator="-" start-placeholder="开始日期" end-placeholder="结束日期"></el-date-picker>
      </el-form-item>

      <el-form-item label="客户创建时间" prop="createTime">
        <el-date-picker
          style="width:205.4px"
          clearable size="small"
          v-model="createTimeRange"
          type="daterange"
          value-format="yyyy-MM-dd"
          start-placeholder="开始日期"
          end-placeholder="结束日期">
        </el-date-picker>
      </el-form-item>
      <el-form-item>
        <el-button type="cyan" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">

      <el-col :span="1.5">
        <el-button
          type="warning"
          icon="el-icon-download"
          size="mini"
          @click="handleExport"
          v-hasPermi="['company:companyVoiceLogs:export']"
        >导出</el-button>
      </el-col>
	  <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table  height="500" border v-loading="loading" :data="companyVoiceLogsList" @selection-change="handleSelectionChange">
      <el-table-column type="selection" width="55" align="center" />
      <el-table-column label="ID" align="center" prop="voiceId" />
      <el-table-column label="公司名" align="center" prop="companyName" />
      <el-table-column label="员工姓名" align="center" prop="userNickName" />
       <el-table-column label="录制地址" align="center"  show-overflow-tooltip prop="voiceUrl" width="350">
          <template slot-scope="scope">
            <audio  v-if="scope.row.voiceUrl!=null"   controls :src="scope.row.voiceUrl"></audio>
          </template>
      </el-table-column>
      <el-table-column label="开始时间" align="center" prop="startTime" width="100">
        <template slot-scope="scope">
          <span>{{ parseTime(scope.row.startTime) }}</span>
        </template>
      </el-table-column>
      <el-table-column label="结束时间" align="center" prop="finishTime" width="100">
        <template slot-scope="scope">
          <span>{{ parseTime(scope.row.finishTime) }}</span>
        </template>
      </el-table-column>
      <el-table-column label="主叫" align="center" prop="callerPhone" />
      <el-table-column label="被叫" align="center" prop="calleePhone" />
      <el-table-column label="时长" align="center" prop="times" width="180">
        <template slot-scope="scope">
          <span v-if="scope.row.voiceUrl!=null">{{ formatTime(scope.row.times)}} </span>
        </template>
      </el-table-column>
      <el-table-column label="计费时长(分)" align="center" prop="billingTime" width="180">
      </el-table-column>
      <el-table-column label="主叫显示号" align="center" prop="displayCallerNumber" width="110"/>
      <el-table-column label="被叫显示号" align="center" prop="displayCalleeNumber" width="110"/>
      <el-table-column label="状态" align="center" prop="status" >
        <template slot-scope="scope">
              <el-tag prop="status" v-for="(item, index) in statusOptions"    v-if="scope.row.status==item.dictValue">{{item.dictLabel}}</el-tag>
        </template>
      </el-table-column>
      <el-table-column label="备注" align="center" prop="remark" width="120" />
      <el-table-column label="操作" fixed="right" align="center" prop="查看" >
        <template slot-scope="scope">
              <el-link  v-if="scope.row.voiceUrl!=null" :href="scope.row.voiceUrl" target="_blank" >下载录音</el-link>
        </template>
      </el-table-column>
    </el-table>

    <pagination
      v-show="total>0"
      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    />


  </div>
</template>

<script>
import { listCompanyVoiceLogs, getCompanyVoiceLogs, delCompanyVoiceLogs, addCompanyVoiceLogs, updateCompanyVoiceLogs, exportCompanyVoiceLogs } from "@/api/company/companyVoiceLogs";
import { getCompanyList } from "@/api/company/company";

import { treeselect } from "@/api/company/companyDept";
import Treeselect from "@riophae/vue-treeselect";
import "@riophae/vue-treeselect/dist/vue-treeselect.css";

export default {
  name: "CompanyVoiceLogs",
  components: { Treeselect },
  watch: {
    // 监听deptId
    'deptId': 'currDeptChange'
  },
  data() {
    return {
      timesOptions:[],
      statusOptions:[],
      companys:[],
      deptOptions:[],
      // 遮罩层
      loading: true,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 通话记录表格数据
      companyVoiceLogsList: [],
      // 弹出层标题
      title: "",
      dateRange: [],
      createTimeRange:[],
      sourceOptions:[],
      // 是否显示弹出层
      open: false,
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        companyId: null,
        voiceTitle: null,
        voiceUrl: null,
        startTime: null,
        endTime: null,
        voiceType: null,
        callerPhone: null,
        calleePhone: null,
        times: null,
        moeny: null,
        displayCallerNumber: null,
        displayCalleeNumber: null,
        deptId:null,

      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
      }
    };
  },
  created() {
    this.getDicts("crm_customer_source").then((response) => {
      this.sourceOptions = response.data;
    });
    this.getDicts("sys_company_voice_logs_status").then((response) => {
      this.statusOptions = response.data;
    });
    this.getDicts("sys_company_voice_logs_times").then((response) => {
      this.timesOptions = response.data;
    });
    getCompanyList().then(response => {
       this.companys = response.data;
       if(this.companys!=null&&this.companys.length>0){
          this.companyId=this.companys[0].companyId;
          this.getTreeselect();
        }
    });
    this.getList();
  },
  methods: {
    formatTime(value) {
      const hours = Math.floor(value / 3600);
      const minutes = Math.floor((value % 3600) / 60);
      const seconds = value % 60;
      if(hours == 0 && minutes == 0 ){
        return `${seconds}秒`;
      }else if(hours == 0 && minutes != 0 ){
        return `${minutes}分钟${seconds}秒`;
      }else{
        return `${hours}小时${minutes}分钟${seconds}秒`;
      }

    },
    /** 查询通话记录列表 */
    getList() {
      this.loading = true;
      if(this.createTimeRange!=null&&this.createTimeRange.length==2){
        this.queryParams.createTimeRange=this.createTimeRange[0]+"--"+this.createTimeRange[1]
      }
      else{
        this.queryParams.createTimeRange=null;
      }
      if(this.dateRange!=null&&this.dateRange.length==2){
        this.queryParams.dateRange=this.dateRange[0]+"--"+this.dateRange[1]
      }
      else{
        this.queryParams.dateRangee=null;
      }

      listCompanyVoiceLogs(this.queryParams).then(response => {
        this.companyVoiceLogsList = response.rows;
        this.total = response.total;
        this.loading = false;
      });
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        voiceId: null,
        companyId: null,
        voiceTitle: null,
        voiceUrl: null,
        startTime: null,
        endTime: null,
        voiceType: null,
        remark: null,
        callerPhone: null,
        calleePhone: null,
        times: null,
        moeny: null,
        displayCallerNumber: null,
        displayCalleeNumber: null
      };
      this.resetForm("form");
      this.dateRange=[];
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.voiceId)
      this.single = selection.length!==1
      this.multiple = !selection.length
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.title = "添加通话记录";
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const voiceId = row.voiceId || this.ids
      getCompanyVoiceLogs(voiceId).then(response => {
        this.form = response.data;
        this.open = true;
        this.title = "修改通话记录";
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate(valid => {
        if (valid) {
          if (this.form.voiceId != null) {
            updateCompanyVoiceLogs(this.form).then(response => {
              if (response.code === 200) {
                this.msgSuccess("修改成功");
                this.open = false;
                this.getList();
              }
            });
          } else {
            addCompanyVoiceLogs(this.form).then(response => {
              if (response.code === 200) {
                this.msgSuccess("新增成功");
                this.open = false;
                this.getList();
              }
            });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const voiceIds = row.voiceId || this.ids;
      this.$confirm('是否确认删除通话记录编号为"' + voiceIds + '"的数据项?', "警告", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        }).then(function() {
          return delCompanyVoiceLogs(voiceIds);
        }).then(() => {
          this.getList();
          this.msgSuccess("删除成功");
        }).catch(function() {});
    },
    /** 导出按钮操作 */
    handleExport() {
      const queryParams = this.queryParams;
      this.$confirm('是否确认导出所有通话记录数据项?', "警告", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        }).then(function() {
          return exportCompanyVoiceLogs(queryParams);
        }).then(response => {
          this.download(response.msg);
        }).catch(function() {});
    },
              /** 查询部门下拉树结构 */
    getTreeselect() {
        var that=this;
        var param={companyId:this.companyId}
        treeselect(param).then((response) => {
          this.deptOptions = response.data;
          console.log(this.deptOptions)
          if(response.data!=null&&response.data.length>0){
            //this.queryParams.deptId=response.data[0].id;
          }
        });
    },
    companyChange(val){
      console.log(val);
      this.companyId=val;
      this.getTreeselect();
    },
    currDeptChange(val){
          console.log(val)
          this.queryParams.deptId=val;
          this.getList();
    },

  }
};
</script>
